// EFileBrowser	 (C)opyright 2006 Jonas Jarvoll
//
// This is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef __BROWSERTAB_H_
#define __BROWSERTAB_H_

#include <stack>
#include <vector>

#include <gui/view.h>
#include <gui/rect.h>
#include <gui/statusbar.h>
#include "eicondirview.h"

class BrowserTab : public os::View
{
public:
	BrowserTab( const os::Rect& cFrame, const os::String& cPath, uint32 nResizeMask = os::CF_FOLLOW_LEFT | os::CF_FOLLOW_TOP,
			   uint32 nFlags = os::WID_WILL_DRAW | os::WID_CLEAR_BACKGROUND | os::WID_FULL_UPDATE_ON_RESIZE );
	~BrowserTab();

	void SetFrame( const os::Rect& cRect, bool bNotifyServer = true );
	void Paint( const os::Rect& cUpdateRect );

	void HandleMessage( os::Message* pcMessage );

	os::String GetPath();
	void SetPath( os::String path, bool save_path = true );

	void SelectionChanged();

	std::vector<os::String> GetSelectedFiles();

	void Back();
	void SetView( EIconDirectoryView::view_type type );
	
	static void SetStatusBarVisibility( bool show = true ) { m_ShowStatusBar = show; }
	static bool IsStatusBarVisible() { return m_ShowStatusBar; }

private:
	void Layout( bool first = false );
	void Unmount();

	EIconDirectoryView* m_Browser;
	os::StatusBar* m_StatusBar;

	static bool m_ShowStatusBar;

	// Stack to keep track of previous path (for the Back button)
	std::stack< os::String > m_PrevoiusPaths;
};

#endif
