// EFileBrowser	 (C)opyright 2006 Jonas Jarvoll
//
// This is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef __DIA_FAV_ADMIN_H_
#define __DIA_FAV_ADMIN_H_

#include <gui/window.h>
#include <gui/listview.h>
#include <gui/button.h>
#include <gui/rect.h>
#include <gui/point.h>
#include <util/message.h>
#include <util/looper.h>

#include "favourites.h"
#include "dia_fav_add.h"
#include "dia_fav_modify.h"

class DiaFavouritesAdmin : public os::Window
{
public:
	DiaFavouritesAdmin( os::Looper* parent, Favourites* favourites, const os::Rect& cFrame );
	~DiaFavouritesAdmin();

	virtual void FrameSized( const os::Point& delta );
	virtual void HandleMessage( os::Message* pcMessage );
	virtual bool OkToQuit( void );

	void Populate();
	void Raise();

private:
	Looper* m_Parent;
	Favourites* m_Favourites;
	DiaFavouritesAdd* m_DiaFavouritesNew;
	DiaFavouritesModify* m_DiaFavouritesModify;

	void NewLink();
	void ModifyLink();
	void DeleteLink();
	void SelectLink();

	enum { MSG_DIA_ADMIN_NEW, MSG_DIA_ADMIN_MODIFY, MSG_DIA_ADMIN_REMOVE, MSG_DIA_ADMIN_SELECT };

	void Layout();

	os::Button* m_New; 
	os::Button* m_Modify; 
	os::Button* m_Remove; 
	os::ListView* m_Links;

private:
};

#endif
