// EFileBrowser	 (C)opyright 2006 Jonas Jarvoll
//
// This is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef __DIA_FAV_MODIFY_H_
#define __DIA_FAV_MODIFY_H_

#include <gui/window.h>
#include <gui/stringview.h>
#include <gui/button.h>
#include <gui/rect.h>
#include <gui/point.h>
#include <util/message.h>
#include <util/looper.h>

#include "sltextview.h"

class DiaFavouritesModify : public os::Window
{
public:
	DiaFavouritesModify( os::Looper* parent, const os::Rect& cFrame );
	~DiaFavouritesModify();

	virtual void FrameSized( const os::Point& delta );
	virtual void HandleMessage( os::Message* pcMessage );
	virtual bool OkToQuit( void );

	void Raise( os::String old_name );

private:
	os::Looper* m_Parent;

	os::String m_OldName;

	enum { MSG_DIA_FAV_MODIFY, MSG_DIA_FAV_CANCEL };

	void Layout();
	void ModifyLink();

	os::StringView* m_LabelPath;
	os::StringView* m_LabelName;
	SLTextView* m_Path;
	SLTextView* m_Name;
	os::Button* m_Modify; 
	os::Button* m_Cancel; 
};

#endif
