
#ifndef __F_GUI_DIRBAR_H__
#define  __F_GUI_DIRBAR_H__

#include <list>
#include <string>
#include <util/string.h>
#include <util/message.h>
#include <util/invoker.h>
#include <gui/rect.h>
#include <gui/point.h>
#include <gui/button.h>
#include <gui/view.h>

class DirBar : public os::View, public os::Invoker
{
	public:
		DirBar( os::Rect cFrame, const os::String& cName, os::Message* pcMessage,
				uint32 nResizeMask = os::CF_FOLLOW_LEFT | os::CF_FOLLOW_TOP,
				uint32 nFlags = os::WID_WILL_DRAW | os::WID_CLEAR_BACKGROUND );

		~DirBar();

		void SetPath( std::string path );
		std::string GetPath();

		status_t SetTarget( const os::Handler* pcHandler, const os::Looper* pcLooper = NULL);

		os::Point GetPreferredSize(bool bLargest);

	private:
		std::string m_CompletePath;

		void ClearPath();
		void AddButton( float& button_pos, std::string label, std::string path );

		os::Message* m_theMessage;
		os::Handler* m_theHandler;
		os::Looper* m_theLooper;

		std::list< os::Button* > m_ListOfButtons;
};

#endif
