// EFileBrowser	 (C)opyright 2006 Jonas Jarvoll
//
// This is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef __DIRTEXTBAR_H__
#define __DIRTEXTBAR_H__

#include <util/string.h>
#include <util/message.h>
#include <gui/rect.h>
#include <gui/point.h>
#include <gui/button.h>
#include <gui/textview.h>
#include <gui/stringview.h>
#include <gui/view.h>

#include "sltextview.h"

class DirTextBar : public os::View
{
	public:
		DirTextBar( os::Rect cFrame, const os::String& cName, os::Message* pcMessage,
					uint32 nResizeMask = os::CF_FOLLOW_LEFT | os::CF_FOLLOW_TOP,
					uint32 nFlags = os::WID_WILL_DRAW | os::WID_CLEAR_BACKGROUND );

		~DirTextBar();

		virtual void SetFrame( const os::Rect& cRect, bool bNotifyServer = true );
		virtual void HandleMessage( os::Message* pcMessage );		
		virtual void AllAttached( void );

		void SetPath( os::String path );
		os::String GetPath();

		os::Point GetPreferredSize( bool bLargest );

	private:
		void Layout();

		os::StringView* m_Text;
		SLTextView* m_Entry;
		os::Button* m_Go;


		os::Message* m_theMessage;
		os::Handler* m_theHandler;
		os::Looper* m_theLooper;	
};

#endif
