// EFileBrowser	 (C)opyright 2006 Jonas Jarvoll
//
// This is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef __EICONDIRVIEW_H_
#define __EICONDIRVIEW_H_

#include <vector>

#include <gui/rect.h>
#include "icondirview.h"
#include <util/string.h>
#include <util/message.h>

class EIconDirectoryView : public os::IconDirectoryView
{
public:
	EIconDirectoryView( const os::Rect& cFrame, const os::String& cPath, uint32 nResizeMask = os::CF_FOLLOW_LEFT | os::CF_FOLLOW_TOP );
    ~EIconDirectoryView();

	void AllAttached();

	void ReRead();
	void SetStatusBarChangeMsg( os::Message* pcMessage );
	virtual void HandleMessage( os::Message* pcMessage );
	virtual void OpenContextMenu( os::Point cPosition, bool bMouseOverIcon );
	std::vector< os::String > GetSelectedFiles();
private:
	bool IsDirectory( os::String path );
	void SendStatusBarChange();

	os::Message* m_StatusBarChangeMsg;

	friend class IconDirectoryView;
};

#endif
