// EFileBrowser	 (C)opyright 2006 Jonas Jarvoll
//
// This is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "favourites.h"

using namespace os;
using namespace std;

Favourites :: Favourites()
{
}

Favourites :: ~Favourites()
{
}

bool Favourites :: NameInUse( os::String name )
{
	for( list<FavouriteNode>::iterator it = m_ListOfFavourites.begin()  ;  it != m_ListOfFavourites.end() ; it++ )
	{
		FavouriteNode fn = (*it);
		if( fn.m_Name == name )
			return true;
	}

	return false;
}

String Favourites :: GetPathFromName( String name )
{
	for( list<FavouriteNode>::iterator it = m_ListOfFavourites.begin()  ;  it != m_ListOfFavourites.end() ; it++ )
	{
		FavouriteNode fn = (*it);
		if( fn.m_Name == name )
			return fn.m_Path;
	}

	return "";
}

void Favourites :: AddFavourite( String name, String path )
{
	FavouriteNode fn( name, path );
	m_ListOfFavourites.push_back( fn );
}

void Favourites :: UpdateFavourite( String old_name, String new_name, String new_path )
{
	for( list<FavouriteNode>::iterator it = m_ListOfFavourites.begin()  ;  it != m_ListOfFavourites.end() ; it++ )
	{
		FavouriteNode fn = (*it);
		if( fn.m_Name == old_name )
		{
			fn.m_Name = new_name;
			fn.m_Path = new_path;
			(*it) = fn;
			return;
		}	
	}

	throw String( "Favourites::UpdateFavourite: Favourite not found!" );
}

int Favourites :: GetFavouritesCount()
{
	return m_ListOfFavourites.size();
}

void Favourites :: GetFavourite( int i, String& name, String& path )
{
	int j = 0;

	for( list<FavouriteNode>::iterator it = m_ListOfFavourites.begin()  ;  it != m_ListOfFavourites.end() ; it++, j++ )
	{
		if( j == i )
		{
			FavouriteNode fn = (*it);
	
			name = fn.m_Name;
			path = fn.m_Path;

			return;		
		}
	}

	name = "";
	path = "";
}

void Favourites :: DeleteFavourite( int i )
{
	int j = 0;

	for( list<FavouriteNode>::iterator it = m_ListOfFavourites.begin()  ;  it != m_ListOfFavourites.end() ; it++, j++ )
	{
		if( j == i )
		{
			m_ListOfFavourites.erase( it );
			return;
		}
	}
}

void Favourites :: DeleteFavourite( String name )
{
	for( list<FavouriteNode>::iterator it = m_ListOfFavourites.begin()  ;  it != m_ListOfFavourites.end() ; it++ )
	{
		FavouriteNode fn = (*it);

		if( fn.m_Name == name )
		{
			m_ListOfFavourites.erase( it );
			return;
		}
	}
}

