// EFileBrowser	 (C)opyright 2006 Jonas Jarvoll
//
// This is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "fileinfo_common.h"

using namespace os;
using namespace std;

FileInfoCommon :: FileInfoCommon( const Rect& cFrame, const String& cTitle, uint32 nResizeMask, uint32 nFlags ) : View( cFrame, cTitle, nResizeMask, nFlags )
{
	m_Table = new TableView( Rect(), "", 2, 7 );
	AddChild( m_Table );

	m_FileNameLabel = new StringView( Rect(), "Name:", "Name:" );
	m_Table->SetChild( m_FileNameLabel, 0, 0, 1.0f );

	m_FileNameEntry = new SLTextView( Rect( 0, 0, 130, 0), "", NULL );
	m_FileNameEntry->SetReadOnly();
	m_Table->SetChild( m_FileNameEntry, 1, 0, 1.0f );

	m_FileTypeLabel = new StringView( Rect(), "Type:", "Type:" );
	m_Table->SetChild( m_FileTypeLabel, 0, 1, 1.0f, 0.5f );

	m_FileTypeEntry = new SLTextView( Rect(), "", NULL );
	m_FileTypeEntry->SetReadOnly();
	m_Table->SetChild( m_FileTypeEntry, 1, 1, 1.0f, 0.5f );

	m_FileOwnerLabel = new StringView( Rect(), "Owner:", "Owner:" );
	m_Table->SetChild( m_FileOwnerLabel, 0, 2, 1.0f, 0.5f );

	m_FileOwnerEntry = new SLTextView( Rect(), "", NULL );
	m_FileOwnerEntry->SetReadOnly();
	m_Table->SetChild( m_FileOwnerEntry, 1, 2, 1.0f, 0.5f );

	m_FileMimeLabel = new StringView( Rect(), "Mime:", "Mime:" );
	m_Table->SetChild( m_FileMimeLabel, 0, 3, 1.0f, 0.5f );

	m_FileMimeEntry = new SLTextView( Rect(), "", NULL );
	m_FileMimeEntry->SetReadOnly();
	m_Table->SetChild( m_FileMimeEntry, 1, 3, 1.0f, 0.5f );
	
	m_FileCreateLabel = new StringView( Rect(), "Created:", "Created:" );
	m_Table->SetChild( m_FileCreateLabel, 0, 4, 1.0f, 0.5f );

	m_FileCreateEntry = new SLTextView( Rect(), "", NULL );
	m_FileCreateEntry->SetReadOnly();
	m_Table->SetChild( m_FileCreateEntry, 1, 4, 1.0f, 0.5f );

	m_FileModifiedLabel = new StringView( Rect(), "Modified:", "Modified:" );
	m_Table->SetChild( m_FileModifiedLabel, 0, 5, 1.0f, 0.5f );

	m_FileModifiedEntry = new SLTextView( Rect(), "", NULL );
	m_FileModifiedEntry->SetReadOnly();
	m_Table->SetChild( m_FileModifiedEntry, 1, 5, 1.0f, 0.5f );

	m_FileSizeLabel = new StringView( Rect(), "Size:", "Size:" );
	m_Table->SetChild( m_FileSizeLabel, 0, 6, 1.0f, 0.5f );

	m_FileSizeEntry = new SLTextView( Rect(), "", NULL );
	m_FileSizeEntry->SetReadOnly();
	m_Table->SetChild( m_FileSizeEntry, 1, 6, 1.0f, 0.5f );

	Layout();
}

FileInfoCommon :: ~FileInfoCommon()
{
/*	delete m_Table;
	delete m_FileNameLabel;
	delete m_FileNameEntry;
	delete m_FileTypeLabel;
	delete m_FileTypeEntry;
	delete m_FileOwnerLabel;
	delete m_FileOwnerEntry;
	delete m_FileMimeLabel;
	delete m_FileMimeEntry;
	delete m_FileCreateLabel;
	delete m_FileCreateEntry;
	delete m_FileModifiedLabel;
	delete m_FileModifiedEntry;
	delete m_FileSizeLabel;
	delete m_FileSizeEntry; */
}

void FileInfoCommon :: SetFrame( const Rect& cRect, bool bNotifyServer )
{
	View::SetFrame( cRect, bNotifyServer );
	
	Layout();
}

Point FileInfoCommon :: GetPreferredSize( bool bLargest ) const
{
	return m_Table->GetPreferredSize( bLargest );
}

void FileInfoCommon :: Layout()
{
	float offset_x = 4.0f, offset_y = 4.0f;

	Rect cBounds = View::GetBounds();

	m_Table->SetFrame( cBounds );

/*	Rect cFileNameLabel = cBounds;
	cFileNameLabel.right = cFileNameLabel.left + m_FileNameLabel->GetPreferredSize( false ).x;
	cFileNameLabel.bottom = cFileNameLabel.top + m_FileNameLabel->GetPreferredSize( false ).y;
	m_FileNameLabel->SetFrame( cFileNameLabel );

	Rect cFileNameEntry = cBounds;
	cFileNameEntry.left = cFileNameLabel.right + offset_x;
	cFileNameEntry.bottom = cFileNameEntry.top + m_FileNameEntry->GetPreferredSize( false ).y;
	m_FileNameEntry->SetFrame( cFileNameEntry );

	cBounds.top += m_FileNameEntry->GetPreferredSize( false ).y + offset_y;

	Rect cFileTypeLabel = cBounds;
	cFileTypeLabel.right = cFileTypeLabel.left + m_FileTypeLabel->GetPreferredSize( false ).x;
	cFileTypeLabel.bottom = cFileTypeLabel.top + m_FileTypeLabel->GetPreferredSize( false ).y;
	m_FileTypeLabel->SetFrame( cFileTypeLabel );

	Rect cFileTypeEntry = cBounds;
	cFileTypeEntry.left = cFileTypeLabel.right + offset_x;
	cFileTypeEntry.bottom = cFileTypeEntry.top + m_FileTypeEntry->GetPreferredSize( false ).y;
	m_FileTypeEntry->SetFrame( cFileTypeEntry );

	cBounds.top += m_FileTypeEntry->GetPreferredSize( false ).y + offset_y;

	Rect cFileOwnerLabel = cBounds;
	cFileOwnerLabel.right = cFileOwnerLabel.left + m_FileOwnerLabel->GetPreferredSize( false ).x;
	cFileOwnerLabel.bottom = cFileOwnerLabel.top + m_FileOwnerLabel->GetPreferredSize( false ).y;
	m_FileOwnerLabel->SetFrame( cFileOwnerLabel );

	Rect cFileOwnerEntry = cBounds;
	cFileOwnerEntry.left = cFileOwnerLabel.right + offset_x;
	cFileOwnerEntry.bottom = cFileOwnerEntry.top + m_FileOwnerEntry->GetPreferredSize( false ).y;
	m_FileOwnerEntry->SetFrame( cFileOwnerEntry );

	cBounds.top += m_FileOwnerEntry->GetPreferredSize( false ).y + offset_y;

	Rect cFileMimeLabel = cBounds;
	cFileMimeLabel.right = cFileMimeLabel.left + m_FileMimeLabel->GetPreferredSize( false ).x;
	cFileMimeLabel.bottom = cFileMimeLabel.top + m_FileMimeLabel->GetPreferredSize( false ).y;
	m_FileMimeLabel->SetFrame( cFileMimeLabel );

	Rect cFileMimeEntry = cBounds;
	cFileMimeEntry.left = cFileMimeLabel.right + offset_x;
	cFileMimeEntry.bottom = cFileMimeEntry.top + m_FileMimeEntry->GetPreferredSize( false ).y;
	m_FileMimeEntry->SetFrame( cFileMimeEntry );

	cBounds.top += m_FileMimeEntry->GetPreferredSize( false ).y + offset_y;

	Rect cFileCreateLabel = cBounds;
	cFileCreateLabel.right = cFileCreateLabel.left + m_FileCreateLabel->GetPreferredSize( false ).x;
	cFileCreateLabel.bottom = cFileCreateLabel.top + m_FileCreateLabel->GetPreferredSize( false ).y;
	m_FileCreateLabel->SetFrame( cFileCreateLabel );

	Rect cFileCreateEntry = cBounds;
	cFileCreateEntry.left = cFileCreateLabel.right + offset_x;
	cFileCreateEntry.bottom = cFileCreateEntry.top + m_FileCreateEntry->GetPreferredSize( false ).y;
	m_FileCreateEntry->SetFrame( cFileCreateEntry );

	cBounds.top += m_FileCreateEntry->GetPreferredSize( false ).y + offset_y;

	Rect cFileModifiedLabel = cBounds;
	cFileModifiedLabel.right = cFileModifiedLabel.left + m_FileModifiedLabel->GetPreferredSize( false ).x;
	cFileModifiedLabel.bottom = cFileModifiedLabel.top + m_FileModifiedLabel->GetPreferredSize( false ).y;
	m_FileModifiedLabel->SetFrame( cFileModifiedLabel );

	Rect cFileModifiedEntry = cBounds;
	cFileModifiedEntry.left = cFileModifiedLabel.right + offset_x;
	cFileModifiedEntry.bottom = cFileModifiedEntry.top + m_FileModifiedEntry->GetPreferredSize( false ).y;
	m_FileModifiedEntry->SetFrame( cFileModifiedEntry );

	cBounds.top += m_FileModifiedEntry->GetPreferredSize( false ).y + offset_y;

	Rect cFileSizeLabel = cBounds;
	cFileSizeLabel.right = cFileSizeLabel.left + m_FileSizeLabel->GetPreferredSize( false ).x;
	cFileSizeLabel.bottom = cFileSizeLabel.top + m_FileSizeLabel->GetPreferredSize( false ).y;
	m_FileSizeLabel->SetFrame( cFileSizeLabel );

	Rect cFileSizeEntry = cBounds;
	cFileSizeEntry.left = cFileSizeLabel.right + offset_x;
	cFileSizeEntry.bottom = cFileSizeEntry.top + m_FileSizeEntry->GetPreferredSize( false ).y;
	m_FileSizeEntry->SetFrame( cFileSizeEntry );

	cBounds.top += m_FileSizeEntry->GetPreferredSize( false ).y + offset_y; */
}

void FileInfoCommon :: Update( FSNode fs )
{
	// Update type
	if( fs.IsDir() )
		m_FileTypeEntry->SetText( "Folder" );
	if( fs.IsLink() )
		m_FileTypeEntry->SetText( "Link" );
	if( fs.IsFile() )
		m_FileTypeEntry->SetText( "File" );
	
	// Update size
	int size = fs.GetSize();
	char zSize[255];
	if( size >= 1000000 )
		sprintf( zSize, "%i Mb", ( int )( size / 1000000 + 1 ) );
	else if( size >= 1000 )
		sprintf( zSize, "%i Kb", ( int )( size / 1000 + 1 ) );
	else
		sprintf( zSize, "%i bytes", ( int )size );
	m_FileSizeEntry->SetText( String( zSize ) );
}

