// EFileBrowser	 (C)opyright 2006 Jonas Jarvoll
//
// This is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef __FILEINFO_COMMON_H__
#define __FILEINFO_COMMON_H__

#include <gui/view.h>
#include <gui/stringview.h>
#include <storage/fsnode.h>
#include "tableview.h"
#include "sltextview.h"

class FileInfoCommon : public os::View
{
public:	
	FileInfoCommon( const os::Rect& cFrame, const os::String& cTitle, uint32 nResizeMask = os::CF_FOLLOW_LEFT | os::CF_FOLLOW_TOP,
			 uint32 nFlags = os::WID_WILL_DRAW | os::WID_CLEAR_BACKGROUND | os::WID_FULL_UPDATE_ON_RESIZE );
	~FileInfoCommon();
	
	void SetFrame( const os::Rect& cRect, bool bNotifyServer = true );

	os::Point GetPreferredSize( bool bLargest ) const;

	void Update( os::FSNode fs );

private:
	void Layout();

	os::TableView* m_Table;

	os::StringView* m_FileNameLabel;
	SLTextView* m_FileNameEntry;

	os::StringView* m_FileTypeLabel;
	SLTextView* m_FileTypeEntry;

	os::StringView* m_FileOwnerLabel;
	SLTextView* m_FileOwnerEntry;

	os::StringView* m_FileMimeLabel;
	SLTextView* m_FileMimeEntry;

	os::StringView* m_FileCreateLabel;
	SLTextView* m_FileCreateEntry;

	os::StringView* m_FileModifiedLabel;
	SLTextView* m_FileModifiedEntry;

	os::StringView* m_FileSizeLabel;
	SLTextView* m_FileSizeEntry;


};

#endif
