// EFileBrowser	 (C)opyright 2006 Jonas Jarvoll
//
// This is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef __SEARCHTAB_H_
#define __SEARCHTAB_H_

#include <gui/view.h>
#include <gui/rect.h>
#include <gui/button.h>
#include <gui/stringview.h>
#include <gui/textview.h>
#include <gui/listview.h>
#include <util/string.h>
#include <util/messenger.h>
#include <util/message.h>

#include "searchkeeper.h"
#include "searchcriteria.h"

class SearchTab : public os::View
{
public:
	SearchTab( const os::Rect& cFrame, const os::String& cTitle, uint32 nResizeMask = os::CF_FOLLOW_LEFT | os::CF_FOLLOW_TOP,
			   uint32 nFlags = os::WID_WILL_DRAW | os::WID_CLEAR_BACKGROUND | os::WID_FULL_UPDATE_ON_RESIZE );
	~SearchTab();

	void AttachedToWindow();
	void DetachedFromWindow();

	void SetFrame( const os::Rect& cRect, bool bNotifyServer = true );
	void Paint( const os::Rect& cUpdateRect );

	void HandleMessage( os::Message* pcMessage );

	void SetSearchCriteria( os::String path, SearchCriteria* searchcritera );
	void DoSearch();
private:
	void Layout();
	void AddSearch( os::Message* pcMessage );

	SearchKeeper* m_SearchKeeper;
	SearchCriteria m_SearchCriteria;

	os::String m_Path;


	os::Button*	 	m_Research;
	os::Button* 	m_Stop;
	os::StringView* m_Label;
	os::TextView* 	m_CurrentPath;
	os::ListView* 	m_SearchResult;

};

#endif
