// EFileBrowser	 (C)opyright 2006 Jonas Jarvoll
//
// This is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef __SIDEBAR_FAVOURITES_H__
#define __SIDEBAR_FAVOURITES_H__

#include <gui/listview.h>
#include <gui/button.h>
#include "sidebar.h"
#include "favourites.h"

class FavouritesSideBar : public SideBar
{
public:
	FavouritesSideBar( const os::Rect& cFrame, const os::String& cTitle, uint32 nResizeMask = os::CF_FOLLOW_LEFT | os::CF_FOLLOW_TOP,
			       uint32 nFlags = os::WID_WILL_DRAW | os::WID_CLEAR_BACKGROUND | os::WID_FULL_UPDATE_ON_RESIZE );
	~FavouritesSideBar();

	virtual void HandleMessage( os::Message* pcMessage );
	virtual void AllAttached( void );

	void Populate( Favourites* favourites );

protected:
	virtual void Layout();
	void SelectLink();

private:
	os::ListView* m_Links;
	os::Button* m_Add; 
};

#endif

