// EFileBrowser	 (C)opyright 2006 Jonas Jarvoll
//
// This is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include <util/message.h>
#include <gui/window.h>
#include <storage/fsnode.h>

#include "sidebar_fileinfo.h"


using namespace os;
using namespace std;

FileInfoSideBar :: FileInfoSideBar( const Rect& cFrame, const String& cTitle, uint32 nResizeMask, uint32 nFlags ) : SideBar( cFrame, cTitle, nResizeMask, nFlags )
{
	m_FileInfoCommon = new FileInfoCommon( Rect(), "fileinfo_common" );
	AddChild( m_FileInfoCommon );

	Layout();
}

FileInfoSideBar :: ~FileInfoSideBar()
{
	delete m_FileInfoCommon;
}

void FileInfoSideBar :: Layout()
{
	Rect cFrame = SideBar::GetFrame();
	ConvertFromParent( &cFrame );

	cFrame.bottom = cFrame.top + m_FileInfoCommon->GetPreferredSize( false ).y;
	m_FileInfoCommon->SetFrame( cFrame );
}

void FileInfoSideBar :: AllAttached( void )
{
	SideBar::AllAttached();

}

void FileInfoSideBar :: HandleMessage( Message* pcMessage )
{

	switch( pcMessage->GetCode() )	//Get the message code from the message
	{		
		default:
			SideBar::HandleMessage( pcMessage );
			break;
	}
}

void FileInfoSideBar :: SelectionChanged( vector<String> files )
{
	if( m_FileInfoCommon->IsVisible() )
		m_FileInfoCommon->Show( false );

	// Check if we have selected more than one file or none
	if( files.size() != 1 )
	{
		Invalidate();
		return;
	}

	try
	{
		FSNode fs( files[0] );

		m_FileInfoCommon->Update( fs );
		m_FileInfoCommon->Show();
	} catch( ... ) {};

	Invalidate();
}
