// EFileBrowser	 (C)opyright 2006 Jonas Jarvoll
//
// This is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include <util/message.h>
#include <gui/window.h>

#include "sidebar_treeview.h"
#include "messages.h"

using namespace os;

TreeViewSideBar :: TreeViewSideBar( const Rect& cFrame, const String& cTitle, uint32 nResizeMask, uint32 nFlags ) : SideBar( cFrame, cTitle, nResizeMask, nFlags )
{
	m_Tree = new FolderTreeView( Rect(), "/" );
	m_Tree->SetDirChangeMsg( new Message ( MSG_SIDEBAR_TREEVIEW_CHANGED_DIR ) );
	AddChild( m_Tree );

	Layout();
}

TreeViewSideBar :: ~TreeViewSideBar()
{
	delete m_Tree;
}

void TreeViewSideBar :: Layout()
{
	Rect cFrame = SideBar::GetFrame();
	ConvertFromParent( &cFrame );
	m_Tree->SetFrame( cFrame );	
}

void TreeViewSideBar :: AllAttached( void )
{
	SideBar::AllAttached();
	m_Tree->SetTarget( this );
}

void TreeViewSideBar :: HandleMessage( Message* pcMessage )
{

	switch( pcMessage->GetCode() )	//Get the message code from the message
	{		
		case MSG_SIDEBAR_TREEVIEW_CHANGED_DIR:
		{
			GetWindow()->HandleMessage( pcMessage );
			break;
		}
		default:
			SideBar::HandleMessage( pcMessage );
			break;
	}
}

void TreeViewSideBar :: SetPath( const String& cPath )
{
	m_Tree->SetPath( cPath );
}
